﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.9
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim sql As SQL
	Public DBFolder As String
	Public DBFilename As String = "sheet.db"
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
CreateDatabase
End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StopAutomaticForeground 'Starter service can start in the foreground state in some edge cases.
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub


Sub CreateDatabase
	Try
		' Obtiene el directorio para guardar la base de datos
		DBFolder = File.DirInternal
		Log("Database Folder: " & DBFolder)
        
		' Verifica si la base de datos ya existe
		If File.Exists(DBFolder, DBFilename) = False Then
			' Inicializa la base de datos
			sql.Initialize(DBFolder, DBFilename, True)
			Log("Database initialized.")
            
			' Crea las tablas
			sql.ExecNonQuery("CREATE TABLE IF NOT EXISTS data ( sheetid INTEGER, sheetsname TEXT)")
			 
			Log("Tables created.")
		Else
			' La base de datos ya existe, inicialízala para su uso
			sql.Initialize(DBFolder, DBFilename, True)
			Log("Database exists and initialized.")
		End If

		' Muestra los nombres de las tablas para confirmar su creación
		GetTableNames
	Catch
		Log("Error while creating database or tables.")
	End Try
End Sub


Sub GetTableNames
	Try
		Dim Cursor1 As Cursor
		Dim TableNames As List
		TableNames.Initialize

		' Consulta para obtener los nombres de las tablas
		Cursor1 = sql.ExecQuery("SELECT name FROM sqlite_master WHERE type='table' ORDER BY name")
		For i = 0 To Cursor1.RowCount - 1
			Cursor1.Position = i
			TableNames.Add(Cursor1.GetString("name"))
		Next
		Cursor1.Close

		' Muestra los nombres de las tablas en el log
		For Each TableName As String In TableNames
			Log("Table: " & TableName)
		Next
	Catch
		Log("Error retrieving table names.")
	End Try
End Sub